# Spring Data Rest

The goal of the project is to provide a flexible and configurable mechanism for writing simple services that can be exposed over HTTP.

The first exporter implemented is a JPA Repository exporter. This takes your JPA repositories and front-ends them with HTTP, allowing you full CRUD capability over your entities, to include managing associations.

### Installation

Installation instructions are in the docs:

* [http://docs.spring.io/spring-data/rest/docs/current/reference/htmlsingle/](http://docs.spring.io/spring-data/rest/docs/current/reference/htmlsingle/)


### License

The Spring Data REST is [Apache 2.0 licensed](http://www.apache.org/licenses/LICENSE-2.0.html).

## Contributing to Spring Data Rest##

Here are some ways for you to get involved in the community:

* Get involved with the Spring community on the Spring Community Forums.  Please help out on the [forum](http://forum.springsource.org/forumdisplay.php?f=27) by responding to questions and joining the debate.
* Create [JIRA](https://jira.springsource.org/browse/DATAREST) tickets for bugs and new features and comment and vote on the ones that you are interested in.  
* Github is for social coding: if you want to write code, we encourage contributions through pull requests from [forks of this repository](http://help.github.com/forking/). If you want to contribute code this way, please reference a JIRA ticket as well covering the specific issue you are addressing.
* Watch for upcoming articles on Spring by [subscribing](http://www.springsource.org/node/feed) to springframework.org

Before we accept a non-trivial patch or pull request we will need you to sign the [contributor's agreement](https://support.springsource.com/spring_committer_signup).  Signing the contributor's agreement does not grant anyone commit rights to the main repository, but it does mean that we can accept your contributions, and you will get an author credit if we do.  Active contributors might be asked to join the core team, and given the ability to merge pull requests.

### Note
We disabled the github issues since we want to use [JIRA](https://jira.springsource.org/browse/DATAREST) as the only only issue tracker.
All open existing issues have been automatically imported into JIRA, so nothing was lost :)
